]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
Import notmuch_0.27.orig.tar.gz
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # Save STDOUT to fd 6 and STDERR to fd 7.
59 exec 6>&1 7>&2
60 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
61 BASH_XTRACEFD=7
62 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
63
64 # Keep the original TERM for say_color and test_emacs
65 ORIGINAL_TERM=$TERM
66
67 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
68 # Otherwise use whatever TERM is currently used so that
69 # users' actual TERM environments are being used in tests.
70 case ${TERM-} in
71         '' | dumb | unknown )
72                 SMART_TERM=vt100 ;;
73         *)
74                 SMART_TERM=$TERM ;;
75 esac
76
77 # For repeatability, reset the environment to known value.
78 LANG=C
79 LC_ALL=C
80 PAGER=cat
81 TZ=UTC
82 TERM=dumb
83 export LANG LC_ALL PAGER TERM TZ
84 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
85 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
86       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
87     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
88     exit 1
89 fi
90 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
91 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
92 TEST_GDB=${TEST_GDB:-gdb}
93 TEST_CC=${TEST_CC:-cc}
94 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
95
96 # Protect ourselves from common misconfiguration to export
97 # CDPATH into the environment
98 unset CDPATH
99
100 unset GREP_OPTIONS
101
102 # For emacsclient
103 unset ALTERNATE_EDITOR
104
105 add_gnupg_home ()
106 {
107     local output
108     [ -d ${GNUPGHOME} ] && return
109     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
110     at_exit_function _gnupg_exit
111     mkdir -m 0700 "$GNUPGHOME"
112     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
113     test_debug "cat $GNUPGHOME/import.log"
114     if (gpg --quick-random --version >/dev/null 2>&1) ; then
115         echo quick-random >> "$GNUPGHOME"/gpg.conf
116     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
117         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
118     fi
119     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
120 }
121
122 # Each test should start with something like this, after copyright notices:
123 #
124 # test_description='Description of this test...
125 # This test checks if command xyzzy does the right thing...
126 # '
127 # . ./test-lib.sh || exit 1
128
129 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
130                 TERM=$ORIGINAL_TERM &&
131                 export TERM &&
132                 [ -t 1 ] &&
133                 tput bold >/dev/null 2>&1 &&
134                 tput setaf 1 >/dev/null 2>&1 &&
135                 tput sgr0 >/dev/null 2>&1
136         ) &&
137         color=t
138
139 while test "$#" -ne 0
140 do
141         case "$1" in
142         -d|--debug)
143                 debug=t; shift ;;
144         -i|--immediate)
145                 immediate=t; shift ;;
146         -h|--help)
147                 help=t; shift ;;
148         -v|--verbose)
149                 verbose=t; shift ;;
150         -q|--quiet)
151                 quiet=t; shift ;;
152         --with-dashes)
153                 with_dashes=t; shift ;;
154         --no-color)
155                 color=; shift ;;
156         --no-python)
157                 # noop now...
158                 shift ;;
159         --valgrind)
160                 valgrind=t; verbose=t; shift ;;
161         --tee)
162                 shift ;; # was handled already
163         *)
164                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
165         esac
166 done
167
168 if test -n "$debug"; then
169     print_subtest () {
170         printf " %-4s" "[$((test_count - 1))]"
171     }
172 else
173     print_subtest () {
174         true
175     }
176 fi
177
178 if test -n "$color"; then
179         say_color () {
180                 (
181                 TERM=$ORIGINAL_TERM
182                 export TERM
183                 case "$1" in
184                         error) tput bold; tput setaf 1;; # bold red
185                         skip)  tput bold; tput setaf 2;; # bold green
186                         pass)  tput setaf 2;;            # green
187                         info)  tput setaf 3;;            # brown
188                         *) test -n "$quiet" && return;;
189                 esac
190                 shift
191                 printf " "
192                 printf "$@"
193                 tput sgr0
194                 print_subtest
195                 )
196         }
197 else
198         say_color() {
199                 test -z "$1" && test -n "$quiet" && return
200                 shift
201                 printf " "
202                 printf "$@"
203                 print_subtest
204         }
205 fi
206
207 error () {
208         say_color error "error: $*\n"
209         GIT_EXIT_OK=t
210         exit 1
211 }
212
213 say () {
214         say_color info "$*"
215 }
216
217 test "${test_description}" != "" ||
218 error "Test script did not set test_description."
219
220 if test "$help" = "t"
221 then
222         echo "Tests ${test_description}"
223         exit 0
224 fi
225
226 test_description_printed=
227 print_test_description ()
228 {
229         test -z "$test_description_printed" || return 0
230         echo
231         echo $this_test: "Testing ${test_description}"
232         test_description_printed=1
233 }
234 if [ -z "$NOTMUCH_TEST_QUIET" ]
235 then
236         print_test_description
237 fi
238
239 test_failure=0
240 test_count=0
241 test_fixed=0
242 test_broken=0
243 test_success=0
244
245 declare -a _exit_functions=()
246
247 at_exit_function () {
248         _exit_functions=($1 ${_exit_functions[@]/$1})
249 }
250
251 rm_exit_function () {
252         _exit_functions=(${_exit_functions[@]/$1})
253 }
254
255 _exit_common () {
256         code=$?
257         trap - EXIT
258         set +ex
259         for _fn in ${_exit_functions[@]}; do $_fn; done
260         rm -rf "$TEST_TMPDIR"
261 }
262
263 trap_exit () {
264         _exit_common
265         if test -n "$GIT_EXIT_OK"
266         then
267                 exit $code
268         else
269                 exec >&6
270                 say_color error '%-6s' FATAL
271                 echo " $test_subtest_name"
272                 echo
273                 echo "Unexpected exit while executing $0. Exit code $code."
274                 exit 1
275         fi
276 }
277
278 trap_signal () {
279         _exit_common
280         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
281         exit $code
282 }
283
284 die () {
285         _exit_common
286         exec >&6
287         say_color error '%-6s' FATAL
288         echo " $*"
289         echo
290         echo "Unexpected exit while executing $0."
291         exit 1
292 }
293
294 GIT_EXIT_OK=
295 # Note: TEST_TMPDIR *NOT* exported!
296 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
297 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
298 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
299 trap 'trap_exit' EXIT
300 trap 'trap_signal' HUP INT TERM
301
302 # Deliver a message with emacs and add it to the database
303 #
304 # Uses emacs to generate and deliver a message to the mail store.
305 # Accepts arbitrary extra emacs/elisp functions to modify the message
306 # before sending, which is useful to doing things like attaching files
307 # to the message and encrypting/signing.
308 emacs_deliver_message ()
309 {
310     local subject="$1"
311     local body="$2"
312     shift 2
313     # before we can send a message, we have to prepare the FCC maildir
314     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
315     # eval'ing smtp-dummy --background will set smtp_dummy_pid
316     smtp_dummy_pid=
317     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
318     test -n "$smtp_dummy_pid" || return 1
319
320     test_emacs \
321         "(let ((message-send-mail-function 'message-smtpmail-send-it)
322                (mail-host-address \"example.com\")
323                (smtpmail-smtp-server \"localhost\")
324                (smtpmail-smtp-service \"25025\"))
325            (notmuch-mua-mail)
326            (message-goto-to)
327            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
328            (message-goto-subject)
329            (insert \"${subject}\")
330            (message-goto-body)
331            (insert \"${body}\")
332            $@
333            (notmuch-mua-send-and-exit))"
334
335     # In case message was sent properly, client waits for confirmation
336     # before exiting and resuming control here; therefore making sure
337     # that server exits by sending (KILL) signal to it is safe.
338     kill -9 $smtp_dummy_pid
339     notmuch new >/dev/null
340 }
341
342 # Pretend to deliver a message with emacs. Really save it to a file
343 # and add it to the database
344 #
345 # Uses emacs to generate and deliver a message to the mail store.
346 # Accepts arbitrary extra emacs/elisp functions to modify the message
347 # before sending, which is useful to doing things like attaching files
348 # to the message and encrypting/signing.
349 #
350 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
351 # at the head of the argument list, they are sent directly to "notmuch
352 # new" after message delivery
353 emacs_fcc_message ()
354 {
355     local nmn_args=''
356     while [[ "$1" =~ ^-- ]]; do
357         nmn_args="$nmn_args $1"
358         shift
359     done
360     local subject="$1"
361     local body="$2"
362     shift 2
363     # before we can send a message, we have to prepare the FCC maildir
364     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
365
366     test_emacs \
367         "(let ((message-send-mail-function (lambda () t))
368                (mail-host-address \"example.com\"))
369            (notmuch-mua-mail)
370            (message-goto-to)
371            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
372            (message-goto-subject)
373            (insert \"${subject}\")
374            (message-goto-body)
375            (insert \"${body}\")
376            $@
377            (notmuch-mua-send-and-exit))" || return 1
378     notmuch new $nmn_args >/dev/null
379 }
380
381 # Add an existing, fixed corpus of email to the database.
382 #
383 # $1 is the corpus dir under corpora to add, using "default" if unset.
384 #
385 # The default corpus is based on about 50 messages from early in the
386 # history of the notmuch mailing list, which allows for reliably
387 # testing commands that need to operate on a not-totally-trivial
388 # number of messages.
389 add_email_corpus ()
390 {
391     corpus=${1:-default}
392
393     rm -rf ${MAIL_DIR}
394     if [ -d $TEST_DIRECTORY/corpora.mail/$corpus ]; then
395         cp -a $TEST_DIRECTORY/corpora.mail/$corpus ${MAIL_DIR}
396     else
397         cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
398         notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
399         mkdir -p $TEST_DIRECTORY/corpora.mail
400         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpora.mail/$corpus
401     fi
402 }
403
404 test_begin_subtest ()
405 {
406     if [ -n "$inside_subtest" ]; then
407         exec 1>&6 2>&7          # Restore stdout and stderr
408         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
409     fi
410     test_subtest_name="$1"
411     test_reset_state_
412     # Redirect test output to the previously prepared file descriptors
413     # 3 and 4 (see below)
414     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
415     exec >&3 2>&4
416     inside_subtest=t
417 }
418
419 # Pass test if two arguments match
420 #
421 # Note: Unlike all other test_expect_* functions, this function does
422 # not accept a test name. Instead, the caller should call
423 # test_begin_subtest before calling this function in order to set the
424 # name.
425 test_expect_equal ()
426 {
427         exec 1>&6 2>&7          # Restore stdout and stderr
428         if [ -z "$inside_subtest" ]; then
429                 error "bug in the test script: test_expect_equal without test_begin_subtest"
430         fi
431         inside_subtest=
432         test "$#" = 2 ||
433         error "bug in the test script: not 2 parameters to test_expect_equal"
434
435         output="$1"
436         expected="$2"
437         if ! test_skip "$test_subtest_name"
438         then
439                 if [ "$output" = "$expected" ]; then
440                         test_ok_
441                 else
442                         testname=$this_test.$test_count
443                         echo "$expected" > $testname.expected
444                         echo "$output" > $testname.output
445                         test_failure_ "$(diff -u $testname.expected $testname.output)"
446                 fi
447     fi
448 }
449
450 # Like test_expect_equal, but takes two filenames.
451 test_expect_equal_file ()
452 {
453         exec 1>&6 2>&7          # Restore stdout and stderr
454         if [ -z "$inside_subtest" ]; then
455                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
456         fi
457         inside_subtest=
458         test "$#" = 2 ||
459         error "bug in the test script: not 2 parameters to test_expect_equal_file"
460
461         file1="$1"
462         file2="$2"
463         if ! test_skip "$test_subtest_name"
464         then
465                 if diff -q "$file1" "$file2" >/dev/null ; then
466                         test_ok_
467                 else
468                         testname=$this_test.$test_count
469                         basename1=`basename "$file1"`
470                         basename2=`basename "$file2"`
471                         cp "$file1" "$testname.$basename1"
472                         cp "$file2" "$testname.$basename2"
473                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
474                 fi
475     fi
476 }
477
478 # Like test_expect_equal, but arguments are JSON expressions to be
479 # canonicalized before diff'ing.  If an argument cannot be parsed, it
480 # is used unchanged so that there's something to diff against.
481 test_expect_equal_json () {
482     # The test suite forces LC_ALL=C, but this causes Python 3 to
483     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
484     # override Python's stdio encoding defaults.
485     local script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
486     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
487         || echo "$1")
488     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
489         || echo "$2")
490     shift 2
491     test_expect_equal "$output" "$expected" "$@"
492 }
493
494 # Sort the top-level list of JSON data from stdin.
495 test_sort_json () {
496     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
497         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
498 }
499
500 test_emacs_expect_t () {
501         test "$#" = 1 ||
502         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
503         if [ -z "$inside_subtest" ]; then
504                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
505         fi
506
507         # Run the test.
508         if ! test_skip "$test_subtest_name"
509         then
510                 test_emacs "(notmuch-test-run $1)" >/dev/null
511
512                 # Restore state after the test.
513                 exec 1>&6 2>&7          # Restore stdout and stderr
514                 inside_subtest=
515
516                 # Report success/failure.
517                 result=$(cat OUTPUT)
518                 if [ "$result" = t ]
519                 then
520                         test_ok_
521                 else
522                         test_failure_ "${result}"
523                 fi
524         else
525                 # Restore state after the (non) test.
526                 exec 1>&6 2>&7          # Restore stdout and stderr
527                 inside_subtest=
528         fi
529 }
530
531 NOTMUCH_NEW ()
532 {
533     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
534 }
535
536 NOTMUCH_DUMP_TAGS ()
537 {
538     # this relies on the default format being batch-tag, otherwise some tests will break
539     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
540 }
541
542 notmuch_drop_mail_headers ()
543 {
544     $NOTMUCH_PYTHON -c '
545 import email, sys
546 msg = email.message_from_file(sys.stdin)
547 for hdr in sys.argv[1:]: del msg[hdr]
548 print(msg.as_string(False))
549 ' "$@"
550 }
551
552 notmuch_search_sanitize ()
553 {
554     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
555 }
556
557 notmuch_search_files_sanitize ()
558 {
559     notmuch_dir_sanitize
560 }
561
562 notmuch_dir_sanitize ()
563 {
564     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
565 }
566
567 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
568 notmuch_show_sanitize ()
569 {
570     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
571 }
572 notmuch_show_sanitize_all ()
573 {
574     sed \
575         -e 's| filename:.*| filename:XXXXX|' \
576         -e 's| id:[^ ]* | id:XXXXX |' | \
577         notmuch_date_sanitize
578 }
579
580 notmuch_json_show_sanitize ()
581 {
582     sed \
583         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
584         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
585         -e 's|"filename": "signature.asc",||g' \
586         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
587         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
588         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
589 }
590
591 notmuch_emacs_error_sanitize ()
592 {
593     local command=$1
594     shift
595     for file in "$@"; do
596         echo "=== $file ==="
597         cat "$file"
598     done | sed  \
599         -e 's/^\[.*\]$/[XXX]/' \
600         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
601 }
602
603 notmuch_date_sanitize ()
604 {
605     sed \
606         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
607 }
608
609 notmuch_uuid_sanitize ()
610 {
611     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
612 }
613
614 notmuch_built_with_sanitize ()
615 {
616     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
617 }
618
619 notmuch_config_sanitize ()
620 {
621     notmuch_dir_sanitize | notmuch_built_with_sanitize
622 }
623
624 notmuch_show_part ()
625 {
626     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
627 }
628
629 # End of notmuch helper functions
630
631 # Use test_set_prereq to tell that a particular prerequisite is available.
632 #
633 # The prerequisite can later be checked for by using test_have_prereq.
634 #
635 # The single parameter is the prerequisite tag (a simple word, in all
636 # capital letters by convention).
637
638 test_set_prereq () {
639         satisfied="$satisfied$1 "
640 }
641 satisfied=" "
642
643 test_have_prereq () {
644         case $satisfied in
645         *" $1 "*)
646                 : yes, have it ;;
647         *)
648                 ! : nope ;;
649         esac
650 }
651
652 declare -A test_missing_external_prereq_
653 declare -A test_subtest_missing_external_prereq_
654
655 # declare prerequisite for the given external binary
656 test_declare_external_prereq () {
657         binary="$1"
658         test "$#" = 2 && name=$2 || name="$binary(1)"
659
660         if ! hash $binary 2>/dev/null; then
661                 test_missing_external_prereq_["${binary}"]=t
662                 eval "
663 $binary () {
664         test_subtest_missing_external_prereq_[\"${name}\"]=t
665         false
666 }"
667         fi
668 }
669
670 # Explicitly require external prerequisite.  Useful when binary is
671 # called indirectly (e.g. from emacs).
672 # Returns success if dependency is available, failure otherwise.
673 test_require_external_prereq () {
674         binary="$1"
675         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
676                 # dependency is missing, call the replacement function to note it
677                 eval "$binary"
678         else
679                 true
680         fi
681 }
682
683 # You are not expected to call test_ok_ and test_failure_ directly, use
684 # the text_expect_* functions instead.
685
686 test_ok_ () {
687         if test "$test_subtest_known_broken_" = "t"; then
688                 test_known_broken_ok_
689                 return
690         fi
691         test_success=$(($test_success + 1))
692         if test -n "$NOTMUCH_TEST_QUIET"; then
693                 return 0
694         fi
695         say_color pass "%-6s" "PASS"
696         echo " $test_subtest_name"
697 }
698
699 test_failure_ () {
700         print_test_description
701         if test "$test_subtest_known_broken_" = "t"; then
702                 test_known_broken_failure_ "$@"
703                 return
704         fi
705         test_failure=$(($test_failure + 1))
706         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
707         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
708         return 1
709 }
710
711 test_failure_message_ () {
712         say_color error "%-6s" "$1"
713         echo " $2"
714         shift 2
715         if [ "$#" != "0" ]; then
716                 echo "$@" | sed -e 's/^/        /'
717         fi
718         if test "$verbose" != "t"; then cat test.output; fi
719 }
720
721 test_known_broken_ok_ () {
722         test_reset_state_
723         test_fixed=$(($test_fixed+1))
724         say_color pass "%-6s" "FIXED"
725         echo " $test_subtest_name"
726 }
727
728 test_known_broken_failure_ () {
729         test_reset_state_
730         test_broken=$(($test_broken+1))
731         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
732                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
733         else
734                 test_failure_message_ "BROKEN" "$test_subtest_name"
735         fi
736         return 1
737 }
738
739 test_debug () {
740         test "$debug" = "" || eval "$1"
741 }
742
743 test_run_ () {
744         test_cleanup=:
745         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
746         eval >&3 2>&4 "$1"
747         eval_ret=$?
748         eval >&3 2>&4 "$test_cleanup"
749         return 0
750 }
751
752 test_skip () {
753         test_count=$(($test_count+1))
754         to_skip=
755         for skp in $NOTMUCH_SKIP_TESTS
756         do
757                 case $this_test.$test_count in
758                 $skp)
759                         to_skip=t
760                         break
761                 esac
762                 case $this_test_bare.$test_count in
763                 $skp)
764                         to_skip=t
765                         break
766                 esac
767         done
768         case "$to_skip" in
769         t)
770                 test_report_skip_ "$@"
771                 ;;
772         *)
773                 test_check_missing_external_prereqs_ "$@"
774                 ;;
775         esac
776 }
777
778 test_check_missing_external_prereqs_ () {
779         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
780                 say_color skip >&1 "missing prerequisites: "
781                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
782                 test_report_skip_ "$@"
783         else
784                 false
785         fi
786 }
787
788 test_report_skip_ () {
789         test_reset_state_
790         say_color skip >&3 "skipping test:"
791         echo " $@" >&3
792         say_color skip "%-6s" "SKIP"
793         echo " $1"
794 }
795
796 test_subtest_known_broken () {
797         test_subtest_known_broken_=t
798 }
799
800 test_expect_success () {
801         exec 1>&6 2>&7          # Restore stdout and stderr
802         if [ -z "$inside_subtest" ]; then
803                 error "bug in the test script: test_expect_success without test_begin_subtest"
804         fi
805         inside_subtest=
806         test "$#" = 1 ||
807         error "bug in the test script: not 1 parameters to test_expect_success"
808
809         if ! test_skip "$test_subtest_name"
810         then
811                 test_run_ "$1"
812                 run_ret="$?"
813                 # test_run_ may update missing external prerequisites
814                 test_check_missing_external_prereqs_ "$@" ||
815                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
816                 then
817                         test_ok_
818                 else
819                         test_failure_ "$1"
820                 fi
821         fi
822 }
823
824 test_expect_code () {
825         exec 1>&6 2>&7          # Restore stdout and stderr
826         if [ -z "$inside_subtest" ]; then
827                 error "bug in the test script: test_expect_code without test_begin_subtest"
828         fi
829         inside_subtest=
830         test "$#" = 2 ||
831         error "bug in the test script: not 2 parameters to test_expect_code"
832
833         if ! test_skip "$test_subtest_name"
834         then
835                 test_run_ "$2"
836                 run_ret="$?"
837                 # test_run_ may update missing external prerequisites,
838                 test_check_missing_external_prereqs_ "$@" ||
839                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
840                 then
841                         test_ok_
842                 else
843                         test_failure_ "exit code $eval_ret, expected $1" "$2"
844                 fi
845         fi
846 }
847
848 # This is not among top-level (test_expect_success)
849 # but is a prefix that can be used in the test script, like:
850 #
851 #       test_expect_success 'complain and die' '
852 #           do something &&
853 #           do something else &&
854 #           test_must_fail git checkout ../outerspace
855 #       '
856 #
857 # Writing this as "! git checkout ../outerspace" is wrong, because
858 # the failure could be due to a segv.  We want a controlled failure.
859
860 test_must_fail () {
861         "$@"
862         test $? -gt 0 -a $? -le 129 -o $? -gt 192
863 }
864
865 # test_cmp is a helper function to compare actual and expected output.
866 # You can use it like:
867 #
868 #       test_expect_success 'foo works' '
869 #               echo expected >expected &&
870 #               foo >actual &&
871 #               test_cmp expected actual
872 #       '
873 #
874 # This could be written as either "cmp" or "diff -u", but:
875 # - cmp's output is not nearly as easy to read as diff -u
876 # - not all diff versions understand "-u"
877
878 test_cmp() {
879         $GIT_TEST_CMP "$@"
880 }
881
882 # This function can be used to schedule some commands to be run
883 # unconditionally at the end of the test to restore sanity:
884 #
885 #       test_expect_success 'test core.capslock' '
886 #               git config core.capslock true &&
887 #               test_when_finished "git config --unset core.capslock" &&
888 #               hello world
889 #       '
890 #
891 # That would be roughly equivalent to
892 #
893 #       test_expect_success 'test core.capslock' '
894 #               git config core.capslock true &&
895 #               hello world
896 #               git config --unset core.capslock
897 #       '
898 #
899 # except that the greeting and config --unset must both succeed for
900 # the test to pass.
901
902 test_when_finished () {
903         test_cleanup="{ $*
904                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
905 }
906
907 test_done () {
908         GIT_EXIT_OK=t
909         test_results_dir="$TEST_DIRECTORY/test-results"
910         mkdir -p "$test_results_dir"
911         test_results_path="$test_results_dir/$this_test"
912
913         echo "total $test_count" >> $test_results_path
914         echo "success $test_success" >> $test_results_path
915         echo "fixed $test_fixed" >> $test_results_path
916         echo "broken $test_broken" >> $test_results_path
917         echo "failed $test_failure" >> $test_results_path
918         echo "" >> $test_results_path
919
920         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
921
922         if [ "$test_failure" = "0" ]; then
923             if [ "$test_broken" = "0" ]; then
924                 rm -rf "$remove_tmp"
925             fi
926             exit 0
927         else
928             exit 1
929         fi
930 }
931
932 emacs_generate_script () {
933         # Construct a little test script here for the benefit of the user,
934         # (who can easily run "run_emacs" to get the same emacs environment
935         # for investigating any failures).
936         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
937 #!/bin/sh
938 export PATH=$PATH
939 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
940
941 # Here's what we are using here:
942 #
943 # --quick              Use minimal customization. This implies --no-init-file,
944 #                      --no-site-file and (emacs 24) --no-site-lisp
945 #
946 # --directory           Ensure that the local elisp sources are found
947 #
948 # --load                Force loading of notmuch.el and test-lib.el
949
950 exec ${TEST_EMACS} --quick \
951         --directory "$NOTMUCH_SRCDIR/emacs" --load notmuch.el \
952         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
953         "\$@"
954 EOF
955         chmod a+x "$TMP_DIRECTORY/run_emacs"
956 }
957
958 test_emacs () {
959         # test dependencies beforehand to avoid the waiting loop below
960         missing_dependencies=
961         test_require_external_prereq dtach || missing_dependencies=1
962         test_require_external_prereq emacs || missing_dependencies=1
963         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
964         test -z "$missing_dependencies" || return
965
966         if [ -z "$EMACS_SERVER" ]; then
967                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
968                 if [ -f "$emacs_tests" ]; then
969                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
970                 else
971                         load_emacs_tests=
972                 fi
973                 server_name="notmuch-test-suite-$$"
974                 # start a detached session with an emacs server
975                 # user's TERM (or 'vt100' in case user's TERM is known dumb
976                 # or unknown) is given to dtach which assumes a minimally
977                 # VT100-compatible terminal -- and emacs inherits that
978                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
979                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
980                                 --no-window-system \
981                                 $load_emacs_tests \
982                                 --eval '(setq server-name \"$server_name\")' \
983                                 --eval '(server-start)' \
984                                 --eval '(orphan-watchdog $$)'" || return
985                 EMACS_SERVER="$server_name"
986                 # wait until the emacs server is up
987                 until test_emacs '()' >/dev/null 2>/dev/null; do
988                         sleep 1
989                 done
990         fi
991
992         # Clear test-output output file.  Most Emacs tests end with a
993         # call to (test-output).  If the test code fails with an
994         # exception before this call, the output file won't get
995         # updated.  Since we don't want to compare against an output
996         # file from another test, so start out with an empty file.
997         rm -f OUTPUT
998         touch OUTPUT
999
1000         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $@)"
1001 }
1002
1003 test_python() {
1004     # Note: if there is need to print debug information from python program,
1005     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1006     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1007         $NOTMUCH_PYTHON -B - > OUTPUT
1008 }
1009
1010 test_ruby() {
1011     MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
1012 }
1013
1014 test_C () {
1015     exec_file="test${test_count}"
1016     test_file="${exec_file}.c"
1017     cat > ${test_file}
1018     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1019     echo "== stdout ==" > OUTPUT.stdout
1020     echo "== stderr ==" > OUTPUT.stderr
1021     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1022     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1023 }
1024
1025
1026 # Creates a script that counts how much time it is executed and calls
1027 # notmuch.  $notmuch_counter_command is set to the path to the
1028 # generated script.  Use notmuch_counter_value() function to get the
1029 # current counter value.
1030 notmuch_counter_reset () {
1031         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1032         if [ ! -x "$notmuch_counter_command" ]; then
1033                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1034                 cat >"$notmuch_counter_command" <<EOF || return
1035 #!/bin/sh
1036
1037 read count < "$notmuch_counter_state_path"
1038 echo \$((count + 1)) > "$notmuch_counter_state_path"
1039
1040 exec notmuch "\$@"
1041 EOF
1042                 chmod +x "$notmuch_counter_command" || return
1043         fi
1044
1045         echo 0 > "$notmuch_counter_state_path"
1046 }
1047
1048 # Returns the current notmuch counter value.
1049 notmuch_counter_value () {
1050         if [ -r "$notmuch_counter_state_path" ]; then
1051                 read count < "$notmuch_counter_state_path"
1052         else
1053                 count=0
1054         fi
1055         echo $count
1056 }
1057
1058 test_reset_state_ () {
1059         test -z "$test_init_done_" && test_init_
1060
1061         test_subtest_known_broken_=
1062         test_subtest_missing_external_prereq_=()
1063 }
1064
1065 # called once before the first subtest
1066 test_init_ () {
1067         test_init_done_=t
1068
1069         # skip all tests if there were external prerequisites missing during init
1070         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1071 }
1072
1073
1074 # Where to run the tests
1075 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1076
1077 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1078
1079 if [ "${NOTMUCH_GMIME_MAJOR}" = 3 ]; then
1080     test_subtest_broken_gmime_3 () {
1081         test_subtest_known_broken
1082     }
1083     test_subtest_broken_gmime_2 () {
1084         true
1085     }
1086 else
1087     test_subtest_broken_gmime_3 () {
1088         true
1089     }
1090     test_subtest_broken_gmime_2 () {
1091         test_subtest_known_broken
1092     }
1093 fi
1094
1095 emacs_generate_script
1096
1097
1098 # Use -P to resolve symlinks in our working directory so that the cwd
1099 # in subprocesses like git equals our $PWD (for pathname comparisons).
1100 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1101
1102 if test "$verbose" = "t"
1103 then
1104         exec 4>&2 3>&1
1105 else
1106         exec 4>test.output 3>&4
1107 fi
1108
1109 for skp in $NOTMUCH_SKIP_TESTS
1110 do
1111         to_skip=
1112         for skp in $NOTMUCH_SKIP_TESTS
1113         do
1114                 case "$this_test" in
1115                 $skp)
1116                         to_skip=t
1117                         break
1118                 esac
1119                 case "$this_test_bare" in
1120                 $skp)
1121                         to_skip=t
1122                         break
1123                 esac
1124         done
1125         case "$to_skip" in
1126         t)
1127                 say_color skip >&3 "skipping test $this_test altogether"
1128                 say_color skip "skip all tests in $this_test"
1129                 test_done
1130         esac
1131 done
1132
1133 # Provide an implementation of the 'yes' utility
1134 yes () {
1135         if test $# = 0
1136         then
1137                 y=y
1138         else
1139                 y="$*"
1140         fi
1141
1142         while echo "$y"
1143         do
1144                 :
1145         done
1146 }
1147
1148 # Fix some commands on Windows
1149 case $(uname -s) in
1150 *MINGW*)
1151         # Windows has its own (incompatible) sort and find
1152         sort () {
1153                 /usr/bin/sort "$@"
1154         }
1155         find () {
1156                 /usr/bin/find "$@"
1157         }
1158         sum () {
1159                 md5sum "$@"
1160         }
1161         # git sees Windows-style pwd
1162         pwd () {
1163                 builtin pwd -W
1164         }
1165         # no POSIX permissions
1166         # backslashes in pathspec are converted to '/'
1167         # exec does not inherit the PID
1168         ;;
1169 *)
1170         test_set_prereq POSIXPERM
1171         test_set_prereq BSLASHPSPEC
1172         test_set_prereq EXECKEEPSPID
1173         ;;
1174 esac
1175
1176 test -z "$NO_PERL" && test_set_prereq PERL
1177 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1178
1179 # test whether the filesystem supports symbolic links
1180 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1181 rm -f y
1182
1183 # convert variable from configure to more convenient form
1184 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1185     glass)
1186         db_ending=glass
1187     ;;
1188     chert)
1189         db_ending=DB
1190     ;;
1191     *)
1192         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1193 esac
1194 # declare prerequisites for external binaries used in tests
1195 test_declare_external_prereq dtach
1196 test_declare_external_prereq emacs
1197 test_declare_external_prereq ${TEST_EMACSCLIENT}
1198 test_declare_external_prereq ${TEST_GDB}
1199 test_declare_external_prereq gpg
1200 test_declare_external_prereq openssl
1201 test_declare_external_prereq gpgsm
1202 test_declare_external_prereq ${NOTMUCH_PYTHON}